// sa2a.h
// Glenn G. Chappell
// 9 Feb 2013
//
// For CS 321 Spring 2013
// A Slow Computation
// Used in Assignment 2, Exercise A
// There is no associated source file

#ifndef FILE_SA2A_H_INCLUDED
#define FILE_SA2A_H_INCLUDED


// Prototypes
inline
int f(int k);


// sa2a
// Function that takes some time to compute
// Parameter n may be any integer.
inline
int sa2a(int n)
{
    int a1 = ((n >= 0) ? (2+n) : (1-n)) ^ 2;
    int a2 = ((n >= 0) ? (2+n) : (2-n)) ^ 3;
    int a3 = ((n >= 0) ? (1+n) : (2-n)) ^ 1;
    int a4 = ((n >= 0) ? (1+n) : (1-n)) ^ 4;

    int b1 = ((a1 >> 2) + (a2 << 1) + 3) ^ 1;
    int b2 = ((a2 >> 1) + (a3 << 2) + 2) ^ 4;
    int b3 = ((a3 >> 1) + (a4 << 1) + 4) ^ 3;
    int b4 = ((a4 >> 2) + (a1 << 2) + 1) ^ 2;

    int c1 = ((b1 ^ b2) + (b3 ^ b4) + 2) % (23 * 27);
    int c2 = ((b1 ^ b3) + (b2 ^ b4) + 1) % (27 * 24);
    int c3 = ((b1 ^ b4) + (b2 ^ b3) + 3) % (24 * 23);

    int k1 = (c1 + c2) ^ 1;
    int k2 = (c2 + c3) ^ 3;
    int k3 = (c3 + c1) ^ 2;

    int t = c1 ^ c2 ^ c3;

    return f(k1) + f(k2) + f(k3) + t;
}


// f
// Helper function for sa2a
// Slow & pointless computation
// Parameter k should be nonnegative.
inline
int f(int k)
{
    int b = 213;

    int kk = (k % 107);
    int s = 0;
    for (int q = 0; q < 103*b; ++q)
    {
        for (int i = -kk; i <= kk; ++i)
        {
            int m1 = i*i+1;
            int m2 = (m1 * (m1-3)) ^ 4;
            int m3 = ((m2-1) ^ 6) + q;
            int g = (i+6)*(i-1)-(i+4)*(i-2);
            s += (g > 2) ? m3 : ((g < 2) ? -m3 : 0);
        }
    }
    return s;
}

#endif //#ifndef FILE_SA2A_H_INCLUDED

